﻿using DistributedGA.Core.Domain;
using DistributedGA.Core.Interface;
using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Text;
using System.Threading.Tasks;

namespace DistributedGA.Core.Implementation
{
    public class WcfPeerListManager : IPeerListManager
    {
        //private const string SERVER_STRING = "http://localhost:9002/DistributedGA.ContactServer/ContactService";
        private const string SERVER_STRING = "http://localhost:9090/DistributedGA.ContactServer/ContactService";

        private IContactService client = null;

        private PeerInfo myself = null;

        List<PeerInfo> allPeers = null;
        List<PeerInfo> peersForMessaging = null;

        public void Init(PeerInfo source)
        {
            client = CreateClient();
            myself = source;
            client.RegisterPeer(source);
        }

        public List<PeerInfo> GetPeerList()
        {
            if(allPeers == null)
            {
                allPeers =  client.GetPeerList(myself);
                peersForMessaging = ChoosePeersForMessaging(allPeers);
            }
            //TODO: maybe always request a new list from the contact server so that he can refresh the heartbeat...
            return peersForMessaging;
        }

        public void SendLogToServer(string msg)
        {
            client.MakeLog(myself, msg);
        }

        private IContactService CreateClient()
        {
            var binding = new BasicHttpBinding();
            var endpoint = new EndpointAddress(SERVER_STRING);
            var myChannelFactory = new ChannelFactory<IContactService>(binding, endpoint);

            IContactService client = null;
            client = myChannelFactory.CreateChannel();
            return client;
        }

        private List<PeerInfo> ChoosePeersForMessaging(List<PeerInfo> allPeers)
        {
            //TODO: strategy: 10% of list random choosen
            int noOfPeers = allPeers.Count / 10; //communicate with 10% of the network
            List<PeerInfo> res = new List<PeerInfo>();

            return allPeers;
        }

    }
}
